package Libconf::GUI::Gtk2::SpinButton;

use ugtk2 qw(:helpers :wrappers :create);
use Libconf::GUI::Gtk2::Widget;

# multiple inheritance, yaaaaaaaaaaaaaaa
our @ISA = qw(Gtk2::SpinButton Libconf::GUI::Gtk2::Widget);

#constructor
#@widget_options is optional
sub new {
    my ($class, $default, $ref_value, $data_mapping, @widget_options) = @_;
    my $adj = create_adjustment(0, 0, 65535);
    my $self = $class->SUPER::new($adj, 1, 0, @widget_options);
    $self->{default_value} = $default;
    $self->{data_mapping} = $data_mapping;
    $self->{ref_value} = $ref_value;
    bless $self, $class;
    gtksignal_connect($self, changed => sub {
                          my $widget = shift;
                          my $value = Gtk2::SpinButton::get_value($widget);
                          $value == Libconf::GUI::Gtk2::Widget::get_value($self) and return;
                          print " setting : -- [" . $value . "]\n";
                          defined $data_mapping and $value = $data_mapping->($value);
                          Libconf::GUI::Gtk2::Widget::set_value($self, $value);
                          print " getvalue : -- " . Libconf::GUI::Gtk2::Widget::get_value($self) . "\n";
                      });
    return $self;
}

sub set_value {
    my $self = shift;
    Gtk2::SpinButton::set_value($self, Libconf::GUI::Gtk2::Widget::set_value($self, @_));
}

1;
